﻿#target photoshop

// Your working documents must be 200% size

function main() {
    if(!documents.length) return;
    
    var sizes = {"xhdpi":"100%", "hdpi":"75%", "mdpi":"50%"};
    // get active document
    var docRef = app.activeDocument;
    $.writeln(docRef.showSliceNumbers);
    var outputFolder = Folder.selectDialog("Please select Output folder");
    if(outputFolder == null ) return;

    // Get current history state
    var history = docRef.activeHistoryState;

    for(var key  in sizes) {
        var size = sizes[key];

        // Resize document
        docRef.resizeImage(size, size);
        
        // save for web
        var saveFile = File(outputFolder + "/" + "image.png");
        sfwPNG24(saveFile);
        
        // rename folder
        var folder = Folder(outputFolder + "/images" );
        if (!folder.exists) {
            folder.create();
            moveFile(outputFolder + "/" + "image.png", outputFolder + "/images/image.png");
        }
        folder.rename(key);
        
        // restore previous state
        docRef.activeHistoryState =  history;
    }
}

function moveFile(oldPath, newPath) {
    var oldFile = new File(oldPath);
    var newFile = new File(newPath);
    
    if(!oldFile.exists) return;

    if(oldFile.copy(newFile)){
        oldFile.remove();
    }else{
        $.writeln('Cant move file');
    }
}

function sfwPNG24(saveFile){
    var pngOpts = new ExportOptionsSaveForWeb; 
    pngOpts.format = SaveDocumentType.PNG;
    pngOpts.PNG8 = false; 
    pngOpts.transparency = true; 
    pngOpts.interlaced = false; 
    pngOpts.quality = 100;
    pngOpts.includeProfile=true;
    activeDocument.exportDocument(new File(saveFile),ExportType.SAVEFORWEB,pngOpts); 
}

main();