﻿#target photoshop

app.bringToFront();

/*------------------ Main Function ------------------*/

function guideLine(position, type){
    var desc = new ActionDescriptor();
    var desc2 = new ActionDescriptor();
    desc2.putUnitDouble( charIDToTypeID('Pstn'), charIDToTypeID('#Pxl'), position );
    desc2.putEnumerated( charIDToTypeID('Ornt'), charIDToTypeID('Ornt'), charIDToTypeID(type) );
    desc.putObject( charIDToTypeID('Nw  '), charIDToTypeID('Gd  '), desc2 );
    executeAction( charIDToTypeID('Mk  '), desc, DialogModes.NO );
}

/* Set ruler units to pixel */
app.preferences.rulerUnits = Units.PIXELS;
var startRulerUnits = app.preferences.rulerUnits;

try{
    /* Get available selection */
    var bounds = app.activeDocument.selection.bounds;
    var guides = app.activeDocument.guides;
    var newGuides = [
        {coordinate: bounds[1].value, direction: Direction.HORIZONTAL}, // top
        {coordinate: bounds[3].value, direction: Direction.HORIZONTAL}, // bottom
        {coordinate: bounds[0].value, direction: Direction.VERTICAL},   // left
        {coordinate: bounds[2].value, direction: Direction.VERTICAL},   // right
    ];
    /* Remove duplicated guidelines */
    for(var i = 0; i < guides.length; i++) {
        var guide = guides[i];
        for(var j = 0; j < newGuides.length; j++) {
            var newGuide = newGuides[j];
            if(newGuide.coordinate == guide.coordinate && newGuide.direction == guide.direction) {
                newGuides.splice(j, 1);
            }
        }
    }
    /* Apply new guidelines */
    for(var i = 0; i < newGuides.length; i++) {
        var newGuide = newGuides[i];
        var direction = (newGuide.direction == Direction.HORIZONTAL)?"Hrzn":"Vrtc";
        guideLine(newGuide.coordinate, direction);
    }
} catch(e){
    $.writeln(e);
}

/* Restore ruler units */
app.preferences.rulerUnits = startRulerUnits;