﻿#target photoshop

app.bringToFront();

//------------------ Main Function ------------------//

var win = new Window("dialog {  \
    orientation: 'column', \
    alignChildren: ['fill', 'top'],  \
    text: 'Selection size',  \
    margins:12, \
    \
    inputGroup: Group {\
        labelWidth: StaticText { text: 'Width' } \
        width: EditText { text: '0', characters: 6, justify: 'left', alignment:['left', 'center']}, \
        labelHeight: StaticText { text: 'Height' } \
        height: EditText { text: '0', characters: 6, justify: 'left', alignment:['left', 'center']}, \
    }\
    bottomGroup: Group{ \
        cancelButton: Button { text: 'Cancel', properties:{name:'Cancel'}, size: [120,24], alignment:['right', 'center'] }, \
        applyButton: Button { text: 'Apply', properties:{name:'Ok'}, size: [120,24], alignment:['left', 'center'] }, \
    }\
}");

win.bottomGroup.applyButton.onClick = function() {
    var startRulerUnits = app.preferences.rulerUnits;
    var dw = activeDocument.width;
    var dh = activeDocument.height;
    var w = parseInt(win.inputGroup.width.text);
    var h = parseInt(win.inputGroup.height.text);
    var top = 0;
    var bottom = h;
    var left = (dw/2) - (w/2);
    var right = left + w;
    
    preferences.rulerUnits = Units.PIXELS
    
    if(w <= 0 || h <= 0) {
        alert('Width or height must larger than 0');
        return false;
    }
    activeDocument.selection.select([[left,top],[right,top],[right,bottom],[left,bottom]]);
    
    // Restore default setting
    preferences.rulerUnits = startRulerUnits;

    // Close dialog
    win.close(1);
};

win.bottomGroup.cancelButton.onClick = function() {
    win.close(1);    
};

// show user the dialog window
win.center();
win.show();