﻿#target photoshop


function main() {
    if(!documents.length) return;
    
    /* Set ruler units to pixel */
    var startRulerUnits = app.preferences.rulerUnits;
    app.preferences.rulerUnits = Units.PIXELS;

    try {
        /* Get available selection */
        var doc = app.activeDocument;
        var bounds = doc.selection.bounds;
        var dw = 64, dh = 32;
        var fontSize = 9;
        var top = Number(bounds[1].value);
        var bottom = Number(bounds[3].value);
        var left = Number(bounds[0].value);
        var right = Number(bounds[2].value);
        var width = (right - left);
        var height = (bottom - top);
        var layer = doc.artLayers.add();
        var text = width + "px\r" + height + "px";
        
        layer.kind = LayerKind.TEXT;
        layer.name = text;
        
        var textLayer = layer.textItem;
        
        textLayer.contents = text;

        // off set the text to be in the middle
        textLayer.size = fontSize + "px";
        textLayer.font= "Helvetica";
        textLayer.justification = Justification.CENTER;
        textLayer.kind = TextType.PARAGRAPHTEXT;
        textLayer.antiAliasMethod = AntiAlias.SHARP
        textLayer.width=  dw + "px";
        textLayer.height= dh + "px";
        textLayer.position = [left + (width/2) - (dw/2), top + (height/2) - (dh/2)];
        
    } catch(e) {
        $.writeln(e);
    }
    
    /* Restore ruler units */
    app.preferences.rulerUnits = startRulerUnits;
}

main();